<?php
/*
Plugin Name: iTracker360
Version: 2.1.8
Plugin URI: https://go.itracker360.com
Description: Provides an easy way to integrate with https://go.itracker360.com
Author: Casey Page
Author URI: https://go.itracker360.com
*/

# Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) {  exit;  } 

# For Development purposes
$local_site_url = get_site_url();
$itracker_local_testing = false;
if ($local_site_url == 'http://localhost/wordpress') {
	$itracker_local_testing = true;
}

if ($itracker_local_testing) {
    $itracker_version_info = "2.1.8"; # Change this above too
    $itracker_api_version = "2.1.3"; # API version to query
    $itracker_host_url = "http://localhost/itracker360/itracker360.com";
    DEFINE('ITRACKER_API_ACCESS_URL', $itracker_host_url.'/tracker/plugin-api/'.$itracker_api_version.'/');
    DEFINE('ITRACKER_API_SERVICE_URL', ITRACKER_API_ACCESS_URL.'/service.php');
    $json_info = $itracker_host_url.'/tracker/plugin-update/local.info.json';      
} else {
    $itracker_version_info = "2.1.8"; # Change this above too
    $itracker_api_version = "2.1.3"; # API version to query
    $itracker_host_url = "https://itracker360.com"; # API hosted domain
    DEFINE('ITRACKER_API_ACCESS_URL', $itracker_host_url.'/tracker/plugin-api/'.$itracker_api_version.'/');
    DEFINE('ITRACKER_API_SERVICE_URL', ITRACKER_API_ACCESS_URL.'/service.php');
    $json_info = 'http://d2ieqaiwehnqqp.cloudfront.net/tracker/plugin-update/info.json';   
}

# For Plugin Updates. Version 2.0
require 'plugin-updates/plugin-update-checker.php';
require 'plugin.core.php';
$myUpdateChecker = PucFactory::buildUpdateChecker(
    $json_info,
    __FILE__,
    'itracker360',
	12
);

$itracker_license = get_option('itracker_license');
$itracker_enabled = get_option('itracker_is_enabled');
$itracker_in_footer = get_option('itracker_in_footer');
itracker_admin_warnings();



# If this is not an admin page
if ( !is_admin() ) {
    if (strlen($itracker_license) == 33 && $itracker_enabled) {
        if ($itracker_local_testing) {
          $itracker_domain_prefix = $itracker_host_url.'/tracker/js/';
        } else {
          $itracker_domain_prefix = "https://d2ieqaiwehnqqp.cloudfront.net/";
        }
    	$itracker_js_url = $itracker_domain_prefix.$itracker_license.".js";

		  # add the script
    	function inft_scripts() {
        global $itracker_js_url;
        global $itracker_version_info;
        global $itracker_in_footer;
				$itracker_params = [];
				$itracker_params['itvr'] = $itracker_version_info;
			  $template = get_page_template();
				# OP3 work-around
			  if (strstr($template, '/templates/blank.php')) {
				  $itracker_params['path'] = '/plugins/itracker360/';
			  }
				$itracker_js_url = add_query_arg( $itracker_params, $itracker_js_url);
        wp_enqueue_script( 'itracker360-js', $itracker_js_url, array(), $itracker_version_info, $itracker_in_footer);
    	}
    	add_action('wp_enqueue_scripts','inft_scripts'); 
    }
}


register_activation_hook(__FILE__, 'itracker_install'); # Runs when plugin is activated 
register_uninstall_hook( __FILE__, 'itracker_remove' ); # Runs on plugin uninstall 

# Add plugin links to the settings page
function itracker_plugin_action_links( $links, $file ) {
	if ( $file == plugin_basename( dirname(__FILE__).'/itracker360.php' ) ) {
		$links[] = '<a href="options-general.php?page=itracker360">'.__('Settings').'</a>';
	}
	return $links;
}
add_filter( 'plugin_action_links', 'itracker_plugin_action_links', 10, 2 );



if ( is_admin() ) {	
    # Generate admin html page
	add_action('admin_menu', 'itracker_admin_menu');
	function itracker_admin_menu() {
    	add_options_page('iTracker360 Options', 'iTracker360', 'administrator', basename(__FILE__), 'itracker_html_page');
	}
}


function itracker_html_page()  {	
	/* Save Options */
	if (isset($_POST['it_submit'])) {
		update_option('itracker_license', strtolower($_POST['itracker_license']));
		update_option('itracker_is_enabled', (isset($_POST['itracker_is_enabled'])) ? 1 : 0);
		update_option('itracker_in_footer', (isset($_POST['itracker_in_footer'])) ? 1 : 0);
		echo '<div id="message" class="updated fade"><p>Option Saved!</p></div>';
	}
	
    /* Get Options */ 
    
    # Keys
    $license = get_option('itracker_license');

    
    # is iTracker enabled?	
	if (get_option('itracker_is_enabled')) {
		$itracker_is_enabled = ' checked="checked"';
	} else {
	    $itracker_is_enabled = '';
	}
                
    # place snippet in footer?
	if (get_option('itracker_in_footer')) {
		$itracker_in_footer = ' checked="checked"';
	} else {
	    $itracker_in_footer = '';
	}
		
	?>
	<div>
	<h2>iTracker360 Options</h2>
	<?php
	    
	if (strlen($license) != 33) {
	   $show_expiration = false;
		if ($license == "") {
			echo "<br />";						
			echo "<b>To Obtain a license visit</b> <a  target='_blank' href='https://go.itracker360.com'>https://go.itracker360.com</a><br />";
			echo "<br />&nbsp;<br />";
		}
		else {
      echo "<br />";
      echo "<h2 style='color: red'>Your license is invalid</h2>";
      echo "<a target='_blank' href='https://itracker360.com/member/'>Login here</a> to find your license.";
      echo "<br />&nbsp;<br />";
		}
	}
	else {
	    $show_expiration = true;
        $data = get_itracker_license_message($license);        
        if (is_array($data)) {
            $license_type = $data['license_type'];            
        } else {
            $license_type = $data; // an error occured
        }
        echo "License Type: <b>".$license_type."</b>";                           
        echo "</font>";
        echo "<br />&nbsp;<br />";

        echo "Here are some resources to help you:";
        echo "<ol>";
        echo "<li><a target='_blank' href='https://members.itracker360.com/home/install/'>Quick Start Video / Setup Guide</a></li>";
        echo "<li><a target='_blank' href='https://www.youtube.com/playlist?list=PLsyveI57IQ5wfGTHbfCcJ2BpfBj7q68FA'>Video Tutorials</a></li>";
        echo "<li><a target='_blank' href='https://go.itracker360.com/pricing/'>Pricing Information for iTracker360 Ultimate</a></li>";
        echo "</ol>";
        echo "<br />&nbsp;<br />";
	}
	?>

	<form id="options_form" method="post" action="">
	<?php wp_nonce_field('update-options'); ?>

	<table width="800">
	<tr>
	<td width="200">Enter Your License Key</td>
	<td><input size="50" maxlength="33"  name="itracker_license" type="text" id="itracker_license" value="<?php echo $license; ?>" /><br />(ex. tcb7cec296a52d7d7a0df7169baa46a21)</td>
	</tr>

<?php
    if ($show_expiration) {       
      echo "<tr><td>License Type</td><td><b>".$license_type."</b></td></tr>";             
    }
?>
	<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	</tr>
    
	<tr>
	<td>Place Snippet In Footer</td>
	<td><input type="checkbox" name="itracker_in_footer" id="itracker_in_footer" value="1" <?php echo $itracker_in_footer; ?> /> Only works if your theme utilizes the wp_footer() hook</td>
	</tr>
	
	<tr>
	<td>Enable iTracker360 Plugin</td>
	<td><input type="checkbox" name="itracker_is_enabled" id="itracker_is_enabled" value="1" <?php echo $itracker_is_enabled; ?> /></td>
	</tr>
    
    </table>


	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="itracker_license" />

	<p>
	<input type="submit" name="it_submit" id="it_submit" value="<?php _e('Save Changes') ?>" />
	</p>

	</form>
	</div>
	<?php
}