<?php
if ( ! defined( 'ABSPATH' ) ) {  exit;  } // Exit if accessed directly
#-------- -----------------------------
#-------- -----------------------------
#-------- -----------------------------
function itracker_test_port($host,$port=80,$timeout=6)
{
	if(function_exists('fsockopen')) { 
        $fsock = @fsockopen($host, $port, $errno, $errstr, $timeout);
        if ( ! $fsock ){            
                return false;
        }
        else {
                return true;
        }
	}

	return true;
}
#-------- -----------------------------
function itracker_install() {
    /* Creates new database field */
    #add_option($name, $value = '', $deprecated = '', $autoload = 'yes')
    add_option("itracker_license", '', '', '');
    add_option("itracker_is_enabled", '1', '', '');
    add_option("itracker_in_footer", '0', '', '');
}
#-------- -----------------------------
function itracker_remove() {
    /* Deletes the database field */
    delete_option('itracker_license');
    delete_option('itracker_is_enabled');
    delete_option('itracker_in_footer');
}
#-------- -----------------------------
function get_itracker_license_message($itracker_license) {
	$request = new WP_Http;
	$params = array('control' => 'get_expdate', 'license_key' => $itracker_license, 'domain' => get_site_url());
	$result = $request->request( ITRACKER_API_SERVICE_URL, array( 'method' => 'POST', 'body' => $params) );
    if (is_array($result)) {        
        if (isset($result['body'])) {             
            $data = json_decode($result['body'], true);
            if ($data['license_type'] == "") {
                $data['license_type'] = 'This license does not exist.';
            }            
            return $data;
        }
    }
    
    return 'Error Communicating With iTracker360.com';
}
#-------- -----------------------------
function itracker_log_api_error($svc, $itracker_license, $msg, $additional_details = array()) {
    $request = new WP_Http;
    $params = array('control' => $svc, 'license_key' => $itracker_license, 'msg' => $msg, 'domain' => get_site_url(), 'additional_details' => $additional_details);
    $result = $request->request( ITRACKER_API_SERVICE_URL, array( 'method' => 'POST', 'body' => $params) );             
    return false; # We failed    
}
#-------- -----------------------------
function itracker_admin_warnings() {	
	$itracker_license = get_option('itracker_license');
	$itracker_enabled = get_option('itracker_is_enabled');
	if ( $itracker_enabled && $itracker_license == '' && !isset($_POST['it_submit']) ) {
		add_action('admin_notices', 'itracker_warning');		
	}
}
#-------- -----------------------------
function itracker_warning() {
	echo "<div id='itracker360-warning' class='updated fade'><p><strong>".__('iTracker360 is almost ready.')."</strong> ".sprintf(__('You must <a href="%1$s">enter your iTracker360 License</a> for it to work.'), "options-general.php?page=itracker360")."</p></div>";
}
#-------- -----------------------------
    